   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('MARQUBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('MARQU001.CLW')
Main                   PROCEDURE   !
     END
            IMPURLHandler(unsigned, STRING)
            MODULE('ImpShell2')
                ShellExecuteM(UNSIGNED,LONG,*CSTRING,LONG,*CSTRING,SIGNED),UNSIGNED,PASCAL,RAW,NAME('SHELLEXECUTEA')
            END
     INCLUDE('CWUTIL.INC'),ONCE
   END

Comp_Name            STRING(100)
person_name          STRING(30)
UserName             STRING(10)
UserPassword         STRING(10)
loc:name             STRING(100)
User_Name            STRING(100)
GLO:VBAF::ViewMode   BYTE,THREAD
Glo:SendAsEmail      BYTE
Glo:ShellExFileName  CSTRING(256)
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'



FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               CLASS(INIClass)                       ! Global non-volatile storage manager
Fetch                  PROCEDURE(),DERIVED                 ! Method added to host embed code
Update                 PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('Marquee.INI', NVD_INI)                      ! Configure INIManager to use INI file
  DctInit
  SYSTEM{PROP:Icon} = 'NOTES.ICO'
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher
    
IMPURLHandler              PROCEDURE (wHandle, URL)                   ! Declare Procedure
URLBuffer            CSTRING(256)
EmptyString          CSTRING(254)
RetHandle            LONG
RetMessage           STRING(100)
  CODE                                                          ! Begin processed code
  URLBuffer = CLIP(URL)
  EmptyString=''
  RetHandle=ShellExecuteM(whandle, 0, URLBuffer, 0, EmptyString, 1)
  IF RetHandle =< 32
    CASE RetHandle
    OF 0
      RetMessage = 'Out of memory or file is corrupt when running program'
    OF 2
      RetMessage = 'File not found'
    OF 3
      RetMessage = 'Path not found'
    OF 5
      RetMessage = 'Sharing violation'
    OF 6
      RetMessage = 'Data segment error'
    OF 8
      RetMessage = 'Not enough memory to run program'
    OF 10
      RetMessage = 'Incorrect Windows version'
    OF 11
      RetMessage = 'Invalid program file.  Non Windows or corrupt .exe file'
    OF 12
      RetMessage = 'Not a Windows program'
    OF 13
      RetMessage = 'MS-DOS 4.0 program'
    OF 14
      RetMessage = 'Unknown program type'
    OF 15
      RetMessage = 'Can not run a real mode program'
    OF 16
      RetMessage = 'This program is already running and can only have one instance running'
    OF 19
      RetMessage = 'This is a compressed program file'
    OF 20
      RetMessage = 'One or more run time libraries are missing or corrupt'
    OF 21
      RetMessage = 'This program requires 32bit extension for Windows'
    OF 31
      RetMessage = 'No program associated with this file'
    Else
      RetMessage = ''
    END
  if RetMessage
     Message(Clip(Retmessage) & '<13><10>' & clip(URL))
  .
  END


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()


INIMgr.Fetch PROCEDURE

  CODE
  Comp_Name = SELF.TryFetch('Preserved','Comp_Name')       ! Resore ' preserved variable' from non-volatile store
  User_Name = SELF.TryFetch('Preserved','User_Name')       ! Resore ' preserved variable' from non-volatile store
  loc:name = SELF.TryFetch('Preserved','loc:name')         ! Resore ' preserved variable' from non-volatile store
  UserName = SELF.TryFetch('Preserved','UserName')         ! Resore ' preserved variable' from non-volatile store
  UserPassword = SELF.TryFetch('Preserved','UserPassword') ! Resore ' preserved variable' from non-volatile store
  person_name = SELF.TryFetch('Preserved','person_name')   ! Resore ' preserved variable' from non-volatile store
  PARENT.Fetch


INIMgr.Update PROCEDURE

  CODE
  PARENT.Update
  SELF.Update('Preserved','Comp_Name',Comp_Name)           ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','User_Name',User_Name)           ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','loc:name',loc:name)             ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','UserName',UserName)             ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','UserPassword',UserPassword)     ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','person_name',person_name)       ! Save 'preserved variable' in non-volatile store

